import { mochaRun } from '../../../util/helpers.js';
import { ForumTest } from '../forum.test-util.js';

describe('Forum', function tests() {
  this.timeout(0);

  const forumTest = new ForumTest({ displayAuthors: true });

  before(async () => {
    await forumTest.setup();
    await forumTest.newExpert();
    await forumTest.newExpert();
  });

  context('Post with multiple authors', async () => {
    let forum;
    let experts;
    let posts;
    let dao;

    before(async () => {
      forum = forumTest.forum;
      experts = forumTest.experts;
      posts = forumTest.posts;
      dao = forumTest.dao;
    });

    it('Post1 has three authors and reputation is distributed among them', async () => {
      const authors = [
        { author: experts[0], weight: 0.5 },
        { author: experts[1], weight: 0.25 },
        { author: experts[2], weight: 0.25 },
      ];
      await forumTest.addPost(authors, 10);
      forum.getPost(posts[0]).value.should.equal(10);

      dao.reputation.valueOwnedBy(experts[0].reputationPublicKey).should.equal(5);
      dao.reputation.valueOwnedBy(experts[1].reputationPublicKey).should.equal(2.5);
      dao.reputation.valueOwnedBy(experts[2].reputationPublicKey).should.equal(2.5);
    });
  });
});

mochaRun();
